require "request_master/version"
require 'rubygems'
require 'bundler/setup'
require 'open-uri'
require 'ostruct'
require 'pg'
require 'sequel'

module RequestMaster

  class << self
    attr_accessor :reqs_db, :check_args, :details, :action_args
    attr_accessor :alloc_args
    def database= (database)
      RequestMaster.reqs_db = database
      require_relative 'request_master/models'
      require_relative 'request_master/req_stats'
      require_relative 'request_master/ip_checks'
      require_relative 'request_master/ip_details'
      require_relative 'request_master/actions'
    end

    def my_ip
      open('http://icanhazip.com').read.strip
    end

    def set_check_defaults (dom_id, avg_freq)
      check_args = OpenStruct.new(dom_id: dom_id, avg_freq: avg_freq)
      RequestMaster.check_args = check_args
      sputs "check defaults were set to #{check_args.to_h}"
      check_args
    end

    def set_action (object, method, *args)
      RequestMaster.action_args =
          OpenStruct.new(
              object: object, method_name: method, args: args
          )
    end

    def action_divide= (lines)
      RequestMaster.action_args.divider = lines
    end

    def set_reallocation (object, method, *args)
      RequestMaster.alloc_args =
          OpenStruct.new(
              object: object, method_name: method, args: args
          )
    end

  end

  class ReqMaster
    attr_accessor :domain, :action_count

    def initialize
      @database = RequestMaster.reqs_db
      @action_count = 0
    end

  end

end

