require_relative '../request_master'
require_relative 'models'

module RequestMaster

  class ReqMaster

    def run_action
      script = RequestMaster.action_args
      result = script.object.send(script.method_name, *script.args)
      @action_count += 1

      unless script.divider.nil?

        if @action_count % script.divider == 0
          puts '------------------------'
        end

      end

      @allocation -= 1
      result
    end

    def allocate (first_run = false)
      my_ip = RequestMaster.my_ip
      checks_out = first_run ? check(my_ip) : false

      until checks_out
        script = RequestMaster.alloc_args
        my_ip = script.object.send(script.method_name, *script.args)
        checks_out = check(my_ip)

        unless checks_out
          sputs "failed because #{RequestMaster.details.to_h}"
        end
      end

      sputs "ip #{my_ip} passed checks"
      sputs ip_stats(my_ip, RequestMaster.check_args.dom_id).to_h.to_s

      comp_alloc(my_ip)
      sputs "allocation = #{@allocation}"
      @allocation
    end

    alias_method :reallocate, :allocate

    def alloc_exhaust?
      @allocation == 0
    end

  end

end
