require_relative '../request_master'
require_relative 'models'

module RequestMaster

  class ReqMaster

    def check_status (ip, dom_id)
      record = IpStatus[public_ip: ip, website: dom_id]
      if record.nil?
        true
      else
        status = record.status
        if ['blocked', 'shielded'].include?(status)
          RequestMaster.details = {
              ip: ip,
              dom_id: dom_id,
              status: status
          }
          false
        else
          true
        end
      end
    end

    def check_frequency (ip, dom_id, avg_freq)
      result = ip_stats(ip, dom_id).avg
      if result.nil? || result <= avg_freq
        true
      else
        RequestMaster.details = {
            ip: ip,
            dom_id: dom_id,
            avg_freq: result
        }
        false
      end
    end

    def check (ip, dom_id = RequestMaster.check_args.dom_id, avg_freq = RequestMaster.check_args.avg_freq)
      check_status(ip, dom_id) && check_freq(ip, dom_id, avg_freq)
    end

    alias_method :check_freq, :check_frequency

  end

end